/***************************************************************************
 ** 
 **  File: writebinex1.c
 **
 **  Description: An example of using write_bin_file.
 **
 **  Date: 17th July 2004
 **
 ***************************************************************************
 ***************************************************************************
 *
 *    Copyright (C) 2004 Scott A. Belmonte
 *    All rights reserved.
 *
 *    Redistribution and use in source and binary forms, with or without 
 *    modification, are permitted provided that the following conditions
 *    are met:
 *
 *    Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *
 *    Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 *    Neither the name of the copyright holder nor the names of any
 *    contributors may be used to endorse or promote products derived from
 *    this software without specific prior written permission.
 * 
 *    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 *    "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 *    LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
 *    A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
 *    OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *    SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
 *    LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
 *    DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
 *    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
 *    (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
 *    OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 ***************************************************************************/

#include <stdlib.h>
#include "writebin.h"

typedef float data_type;

int main()
{
    FILE          *file_p;
    unsigned short width;
    unsigned short height;
    data_type     *data_p;
    int    i;

    width  = 480;
    height = 620;
    data_p = (data_type *) malloc(width*height*sizeof(data_type));


    if (data_p != NULL && (file_p = fopen("example.dat", "wb")) != NULL)
    {
        /* Initialise data with an arbitrary number, 3.1416 for this example */
        for (i = 0; i < width*height; i++)
        {
            data_p[i] = (data_type) 3.1416;
        }

        if (write_bin_file(&width, sizeof(width), 1, file_p, DONT_SWAP) != 1)
        {
            fprintf(stderr, "Error writing width!\n");
            fclose(file_p);
            exit(1);
        }

        if (write_bin_file(&height, sizeof(height), 1, file_p, DONT_SWAP) != 1)
        {
            fprintf(stderr, "Error writing height!\n");
            fclose(file_p);
            exit(1);
        }

        if (write_bin_file(data_p, sizeof(data_type), width*height, file_p, DONT_SWAP) != width*height)
        {
            fprintf(stderr, "Error writing data!\n");
            fclose(file_p);
            exit(1);
        }

        fclose(file_p);
    }

    return 0;
}